Index: tmp/org.txm.searchengine.cqp.rcp/src/org/txm/searchengine/cqp/rcp/editors/InformationEditor.java
===================================================================
--- tmp/org.txm.searchengine.cqp.rcp/src/org/txm/searchengine/cqp/rcp/editors/InformationEditor.java	(revision 0)
+++ tmp/org.txm.searchengine.cqp.rcp/src/org/txm/searchengine/cqp/rcp/editors/InformationEditor.java	(revision 653)
@@ -0,0 +1,80 @@
+package org.txm.searchengine.cqp.rcp.editors;
+
+import java.io.File;
+
+import org.eclipse.swt.SWT;
+import org.eclipse.swt.browser.Browser;
+import org.eclipse.swt.events.SelectionEvent;
+import org.eclipse.swt.events.SelectionListener;
+import org.eclipse.swt.layout.GridData;
+import org.eclipse.swt.layout.GridLayout;
+import org.eclipse.swt.layout.RowData;
+import org.eclipse.swt.widgets.Composite;
+import org.eclipse.swt.widgets.Label;
+import org.eclipse.swt.widgets.Spinner;
+import org.eclipse.ui.IEditorInput;
+import org.eclipse.ui.IEditorSite;
+import org.eclipse.ui.PartInitException;
+import org.txm.rcp.editors.TXMEditor;
+import org.txm.searchengine.cqp.CQPPreferences;
+import org.txm.searchengine.cqp.core.functions.information.Information;
+
+public class InformationEditor extends TXMEditor<Information> {
+
+	private Spinner maxScore;
+	private Browser browser;
+	protected Information diag;
+
+	@Override
+	public void init(IEditorSite site, IEditorInput input) throws PartInitException {
+		super.init(site, input);
+		if (getResult() instanceof Information)
+			this.diag = (Information) getResult();
+	}
+	
+	@Override
+	public void _createPartControl(Composite parent) {
+//		super.createPartControl(parent);
+		
+		Composite parametersArea = getCommandParametersGroup();
+		
+		new Label(parametersArea, SWT.NONE).setText("V max");
+
+		maxScore = new Spinner(parametersArea, SWT.BORDER);
+		maxScore.setToolTipText("The maximum number of word property values to show");
+		maxScore.setMinimum(0);
+		maxScore.setSelection(CQPPreferences.getInt(CQPPreferences.MAXVALUE, CQPPreferences.PREFERENCES_NODE));
+		RowData gdata = new RowData();
+		gdata.width = 100;
+		maxScore.setLayoutData(gdata);
+		maxScore.addSelectionListener(new SelectionListener() {
+			@Override
+			public void widgetSelected(SelectionEvent e) {
+				compute(true);
+			}
+			
+			@Override
+			public void widgetDefaultSelected(SelectionEvent e) { }
+		});
+		
+		Composite displayArea = getResultArea();
+		displayArea.setLayout(new GridLayout(1, true));
+		
+		browser = new Browser(displayArea, SWT.NONE);
+		browser.setLayoutData(new GridData(GridData.FILL, GridData.FILL, true, true));
+	}
+	
+	@Override
+	public void updateEditorFromResult(boolean update) {
+		File file = diag.getHTMLFile();
+		if (file.exists()) {
+			browser.setUrl(file.getAbsolutePath());
+		}
+	}
+
+	@Override
+	public void updateResultFromEditor() {
+		if (!maxScore.isDisposed())
+			this.diag.setParameters(maxScore.getSelection());
+	}
+}

Index: tmp/org.txm.searchengine.cqp.rcp/.settings/org.eclipse.core.resources.prefs
===================================================================
--- tmp/org.txm.searchengine.cqp.rcp/.settings/org.eclipse.core.resources.prefs	(revision 652)
+++ tmp/org.txm.searchengine.cqp.rcp/.settings/org.eclipse.core.resources.prefs	(revision 653)
@@ -1,3 +1,3 @@
 eclipse.preferences.version=1
-encoding//src/org/txm/searchengine/cqp/rcp/messages_fr.properties=UTF-8
-encoding//src/org/txm/searchengine/cqp/rcp/messages_ru.properties=UTF-8
+encoding//src/org/txm/searchengine/cqp/rcp/messages/messages_fr.properties=UTF-8
+encoding//src/org/txm/searchengine/cqp/rcp/messages/messages_ru.properties=UTF-8
Index: tmp/org.txm.searchengine.cqp.rcp/META-INF/MANIFEST.MF
===================================================================
--- tmp/org.txm.searchengine.cqp.rcp/META-INF/MANIFEST.MF	(revision 652)
+++ tmp/org.txm.searchengine.cqp.rcp/META-INF/MANIFEST.MF	(revision 653)
@@ -11,8 +11,9 @@
  org.eclipse.core.commands;bundle-version="3.6.100",
  org.eclipse.ui.workbench;bundle-version="3.106.2",
  org.eclipse.ui
-Export-Package: org.txm.rcp.commands.base,
- org.txm.searchengine.cqp.rcp,
- org.txm.searchengine.cqp.rcp.command,
- org.txm.searchengine.cqp.rcp.editor,
+Export-Package: org.txm.searchengine.cqp.rcp.adapters,
+ org.txm.searchengine.cqp.rcp.editors,
+ org.txm.searchengine.cqp.rcp.handlers,
+ org.txm.searchengine.cqp.rcp.handlers.base,
+ org.txm.searchengine.cqp.rcp.messages,
  org.txm.searchengine.cqp.rcp.preferences
Index: tmp/org.txm.utils/src/org/txm/utils/messages/Utf8NLS.java
===================================================================
--- tmp/org.txm.utils/src/org/txm/utils/messages/Utf8NLS.java	(revision 652)
+++ tmp/org.txm.utils/src/org/txm/utils/messages/Utf8NLS.java	(revision 653)
@@ -2,8 +2,6 @@
 
 import java.lang.reflect.Field;
 import java.lang.reflect.Modifier;
-import java.util.HashMap;
-import java.util.Map;
 
 import org.eclipse.osgi.util.NLS;
 
@@ -25,7 +23,7 @@
 	 */
 	public static void initializeMessages(final Class<?> clazz) {
 		// initialize resource bundle
-		initializeMessages(clazz.getPackage().getName()+".messages", clazz);
+		initializeMessages(clazz.getPackage().getName() + ".messages", clazz); //$NON-NLS-1$
 	}
 	
 	/**
@@ -53,7 +51,7 @@
 				field.setAccessible(true);
 			try {
 				final String rawValue = (String) field.get(null);
-				field.set(null, new String(rawValue.getBytes("ISO-8859-1"), "UTF-8"));
+				field.set(null, new String(rawValue.getBytes("ISO-8859-1"), "UTF-8")); //$NON-NLS-1$ //$NON-NLS-2$
 			}
 			catch(Exception e) {
 				//	e.printStackTrace();
Index: tmp/org.txm.synopticeditor.rcp/META-INF/MANIFEST.MF
===================================================================
--- tmp/org.txm.synopticeditor.rcp/META-INF/MANIFEST.MF	(revision 652)
+++ tmp/org.txm.synopticeditor.rcp/META-INF/MANIFEST.MF	(revision 653)
@@ -3,7 +3,6 @@
 Bundle-Name: %Bundle-Name
 Bundle-SymbolicName: org.txm.synopticeditor.rcp;singleton:=true
 Bundle-Version: 1.0.0.qualifier
-Bundle-Activator: synopticeditor.Activator
 Require-Bundle: org.txm.concordance.rcp;bundle-version="1.0.0",
  org.txm.core;bundle-version="0.7.0",
  org.eclipse.ui,
@@ -16,8 +15,9 @@
  org.txm.searchengine.cqp.core;bundle-version="1.1.0"
 Bundle-RequiredExecutionEnvironment: JavaSE-1.6
 Bundle-ActivationPolicy: lazy
-Export-Package: org.txm.rcp.synoptic.commands,
- org.txm.rcp.synoptic.editor,
- org.txm.rcp.synoptic.editor.ext,
- synopticeditor
+Export-Package: org.txm.synopticedition.rcp.editors,
+ org.txm.synopticedition.rcp.editors.ext,
+ org.txm.synopticedition.rcp.handlers,
+ org.txm.synopticedition.rcp.messages,
+ org.txm.synopticedition.rcp.preferences
 Bundle-Vendor: Textometrie.org
Index: tmp/org.txm.synopticeditor.rcp/schema/org.txm.synopticeditor.toolbarbutton.exsd
===================================================================
--- tmp/org.txm.synopticeditor.rcp/schema/org.txm.synopticeditor.toolbarbutton.exsd	(revision 652)
+++ tmp/org.txm.synopticeditor.rcp/schema/org.txm.synopticeditor.toolbarbutton.exsd	(revision 653)
@@ -55,7 +55,7 @@
                   
                </documentation>
                <appinfo>
-                  <meta.attribute kind="java" basedOn="org.txm.rcp.synoptic.editor.ext.ToolbarButton:"/>
+                  <meta.attribute kind="java" basedOn="org.txm.synopticedition.rcp.editors.ext.ToolbarButton:"/>
                </appinfo>
             </annotation>
          </attribute>
Index: tmp/org.txm.synopticeditor.rcp/src/org/txm/synopticedition/rcp/handlers/BackToText.java
===================================================================
--- tmp/org.txm.synopticeditor.rcp/src/org/txm/synopticedition/rcp/handlers/BackToText.java	(revision 0)
+++ tmp/org.txm.synopticeditor.rcp/src/org/txm/synopticedition/rcp/handlers/BackToText.java	(revision 653)
@@ -0,0 +1,271 @@
+// Copyright © 2010-2013 ENS de Lyon.
+// Copyright © 2007-2010 ENS de Lyon, CNRS, INRP, University of
+// Lyon 2, University of Franche-Comté, University of Nice
+// Sophia Antipolis, University of Paris 3.
+// 
+// The TXM platform is free software: you can redistribute it
+// and/or modify it under the terms of the GNU General Public
+// License as published by the Free Software Foundation,
+// either version 2 of the License, or (at your option) any
+// later version.
+// 
+// The TXM platform is distributed in the hope that it will be
+// useful, but WITHOUT ANY WARRANTY; without even the implied
+// warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
+// PURPOSE. See the GNU General Public License for more
+// details.
+// 
+// You should have received a copy of the GNU General
+// Public License along with the TXM platform. If not, see
+// http://www.gnu.org/licenses.
+// 
+// 
+// 
+// $LastChangedDate:$
+// $LastChangedRevision:$
+// $LastChangedBy:$ 
+//
+package org.txm.synopticedition.rcp.handlers;
+
+
+import java.util.ArrayList;
+import java.util.HashMap;
+import java.util.HashSet;
+import java.util.List;
+
+import javax.sound.sampled.Line;
+
+import org.eclipse.core.commands.ExecutionEvent;
+import org.eclipse.core.commands.ExecutionException;
+import org.eclipse.e4.ui.workbench.modeling.EModelService;
+import org.eclipse.jface.viewers.ISelection;
+import org.eclipse.jface.viewers.IStructuredSelection;
+import org.eclipse.osgi.util.NLS;
+import org.eclipse.ui.IEditorPart;
+import org.eclipse.ui.IWorkbenchPage;
+import org.eclipse.ui.IWorkbenchWindow;
+import org.eclipse.ui.handlers.HandlerUtil;
+import org.txm.concordance.core.functions.Concordance;
+import org.txm.concordance.rcp.editors.ConcordanceEditor;
+import org.txm.concordance.rcp.handlers.BackToTextCommand;
+import org.txm.objects.Text;
+import org.txm.rcp.StatusLine;
+import org.txm.rcp.utils.SWTEditorsUtils;
+import org.txm.searchengine.cqp.AbstractCqiClient;
+import org.txm.searchengine.cqp.CQPEngine;
+import org.txm.searchengine.cqp.corpus.Corpus;
+import org.txm.searchengine.cqp.corpus.Property;
+import org.txm.searchengine.cqp.corpus.StructuralUnit;
+import org.txm.searchengine.cqp.corpus.query.Match;
+import org.txm.synopticedition.rcp.editors.SynopticEditionEditor;
+import org.txm.synopticedition.rcp.editors.EditionPanel.RGBA;
+import org.txm.synopticedition.rcp.messages.SynopticEditionUIMessages;
+import org.txm.utils.logger.Log;
+
+import cern.colt.Arrays;
+
+/**
+ * Open a text edition from: a concordance Line 
+ * @author mdecorde.
+ */
+public class BackToText extends BackToTextCommand {
+
+	/** The Constant ID. */
+	public final static String ID = "org.txm.synopticedition.rcp.handlers.BackToText"; //$NON-NLS-1$
+	public final static RGBA lightred = new RGBA(249,208,208);
+	public final static RGBA red = new RGBA(249, 160, 160);
+	//TODO: this kind of link associations must be transfered to a TXMEditor class
+	private static HashMap<ConcordanceEditor, SynopticEditionEditor> associatedEditors = new HashMap<ConcordanceEditor, SynopticEditionEditor>();
+	private static HashMap<ConcordanceEditor, List<String>> associatedEditorsPreviousOtherWordIDs = new HashMap<ConcordanceEditor, List<String>>();
+	private static HashMap<ConcordanceEditor, List<String>> associatedEditorsPreviousLineids = new HashMap<ConcordanceEditor, List<String>>();
+
+	/* (non-Javadoc)
+	 * @see org.eclipse.core.commands.AbstractHandler#execute(org.eclipse.core.commands.ExecutionEvent)
+	 */
+	@Override
+	public Object execute(ExecutionEvent event) throws ExecutionException {
+		IWorkbenchWindow wb = HandlerUtil.getActiveWorkbenchWindow(event);
+		IEditorPart ieditor = wb.getActivePage().getActiveEditor();
+		if (!(ieditor instanceof ConcordanceEditor)) {
+			return null;
+		}
+		ConcordanceEditor concordanceEditor = (ConcordanceEditor)ieditor;
+		ISelection sel = wb.getSelectionService().getSelection();
+		if (sel instanceof IStructuredSelection) {
+			IStructuredSelection selection = (IStructuredSelection) sel;
+			if (selection.getFirstElement() instanceof Match) {
+				backToText(concordanceEditor, (Match)(selection.getFirstElement()));
+			} else {
+				System.out.println(SynopticEditionUIMessages.BackToText_1+selection);
+			}
+		} else {
+			System.out.println(SynopticEditionUIMessages.BackToText_2);
+		}
+		return null;
+	}
+
+	/**
+	 * Open edition.
+	 *
+	 * @param corpus the corpus
+	 * @return the object
+	 */
+	@Override
+	public boolean backToText(ConcordanceEditor editor, Match match) {
+		Concordance conc = editor.getConcordance();
+		Corpus corpus = editor.getCorpus();
+
+		try {
+			if (match == null) return false;
+
+			StructuralUnit textS = null;
+			String textid = ""; //$NON-NLS-1$
+			String baseid = ""; //$NON-NLS-1$
+			
+			Property xProperty = corpus.getProperty("x"), yProperty, wProperty, hProperty;
+			String x="0",y="0",w="0",h="0";
+			int[] pos = null;
+			if (xProperty != null) {
+				yProperty = corpus.getProperty("y");
+				if (yProperty != null) {
+					wProperty = corpus.getProperty("w");
+					if (wProperty != null) {
+						AbstractCqiClient CQI = CQPEngine.getCqiClient();
+						int[] cpos = {match.getStart()};
+						hProperty = corpus.getProperty("h");
+						if (hProperty != null) {
+							x = CQI.cpos2Str(xProperty.getQualifiedName(), cpos)[0];
+							y = CQI.cpos2Str(yProperty.getQualifiedName(), cpos)[0];
+							w = CQI.cpos2Str(wProperty.getQualifiedName(), cpos)[0];
+							h = CQI.cpos2Str(hProperty.getQualifiedName(), cpos)[0];
+							
+							pos = new int[4];
+							pos[0] = Integer.parseInt(x);
+							pos[1] = Integer.parseInt(y);
+							pos[2] = Integer.parseInt(w);
+							pos[3] = Integer.parseInt(h);
+						}
+					}
+				}
+			}
+			
+			
+			String projectid = ""; //$NON-NLS-1$
+			try {
+				textS = corpus.getStructuralUnit("text"); //$NON-NLS-1$
+				Property textP = textS.getProperty("id"); //$NON-NLS-1$
+				textid = match.getValueForProperty(textP);// get text via text struct property id
+			} catch (Exception e2) {
+				System.out.println("The corpus has no text_id property" + e2); //$NON-NLS-1$
+				org.txm.rcp.utils.Logger.printStackTrace(e2);
+				return false;
+			}
+
+			Log.info("Loading line informations..."); //$NON-NLS-1$
+
+			SynopticEditionEditor attachedBrowserEditor = associatedEditors.get(editor);
+			if (attachedBrowserEditor!= null && attachedBrowserEditor.isDisposed()) {
+				associatedEditorsPreviousOtherWordIDs.put(editor, new ArrayList<String>());
+				associatedEditorsPreviousLineids.put(editor, new ArrayList<String>());
+			}
+			List<String> previousOtherWordIDs = associatedEditorsPreviousOtherWordIDs.get(editor);
+			List<String> previousLineids = associatedEditorsPreviousLineids.get(editor);
+			
+			if (attachedBrowserEditor == null || attachedBrowserEditor.isDisposed()) {
+				String[] editionsToOpen = OpenEdition.getDefaultEditions(corpus);
+
+				if (editionsToOpen.length == 0) { // the defaultEdition parameter is not set
+					ArrayList<String> editionNames = corpus.getEditionNames();
+					if (editionNames.size() > 0) { // use the first edition declared
+						editionsToOpen = new String[1];
+						editionsToOpen[0] = editionNames.get(0);
+						Log.info(SynopticEditionUIMessages.BackToText_0+editionNames.get(0));
+					} else { // no edition in the corpus
+						Log.info(SynopticEditionUIMessages.BackToText_4);
+						editionsToOpen = new String[0];
+						return false;
+					}
+				} else {
+					Log.info(SynopticEditionUIMessages.BackToText_5+Arrays.toString(editionsToOpen));
+				}
+
+				attachedBrowserEditor = OpenEdition.openEdition(corpus, editionsToOpen);
+				associatedEditors.put(editor, attachedBrowserEditor);
+				SWTEditorsUtils.addEditor(editor, attachedBrowserEditor, EModelService.ABOVE);
+			}
+			
+			// remove previous highlighted words
+			if (previousOtherWordIDs != null) {
+				//System.out.println("remove previousOtherWordIDs="+previousOtherWordIDs);
+				attachedBrowserEditor.removeHighlightWordsById(lightred, previousOtherWordIDs);
+				associatedEditorsPreviousOtherWordIDs.remove(editor); // free mem
+			}
+			if (previousLineids != null) {
+				//System.out.println("remove previousLineids="+previousLineids);
+				attachedBrowserEditor.removeHighlightWordsById(red, previousLineids);
+				associatedEditorsPreviousLineids.remove(editor); // free mem
+			}
+			
+			//System.out.println("getKeywordsId from "+editor.getTopLine()+" to "+editor.getBottomLine() + 1);
+			List<String> otherWordIDs = conc.getKeywordsId(textid, editor.getTopLine(), editor.getBottomLine() + 1);
+			//System.out.println("getKeywordsId="+otherWordIDs);
+			List<String> lineids = null;
+			try {
+				lineids = match.getValuesForProperty(corpus.getProperty("id")); //$NON-NLS-1$
+			} catch (Exception e1) {
+				org.txm.rcp.utils.Logger.printStackTrace(e1);
+				return false;
+			}
+			Log.info(NLS.bind("Project id {0} Corpus (Base) id {1} Text id {2}",  //$NON-NLS-1$
+					new Object[]{projectid, baseid, textid}));
+			
+			otherWordIDs.removeAll(lineids); // remove the pivot from others words 
+			
+			Text text = corpus.getMainCorpus().getText(textid);
+			if (text == null) {
+				System.out.println(NLS.bind("BackToText: Text {0} is missing", textid)); //$NON-NLS-1$
+				StatusLine.setMessage(NLS.bind("BackToText: Text {0} is missing", textid)); //$NON-NLS-1$
+				Log.severe(NLS.bind("BackToText: Text {0} is missing", textid)); //$NON-NLS-1$
+				return false;
+			}
+
+			String line_wordid = lineids.get(0);
+			if (line_wordid == null) {
+				System.out.println(SynopticEditionUIMessages.BackToText_3);
+				return false;				
+			}
+			
+			
+			String focusid = null;
+			if (lineids.size() > 0) focusid = lineids.get(0);
+				
+			//System.out.println("add otherWordIDs="+otherWordIDs);
+			attachedBrowserEditor.addHighlightWordsById(lightred, otherWordIDs);
+			
+			//System.out.println("add linesids="+lineids);
+			attachedBrowserEditor.addHighlightWordsById(red, lineids);
+			
+			associatedEditorsPreviousOtherWordIDs.put(editor, otherWordIDs);
+			associatedEditorsPreviousLineids.put(editor, lineids);
+						
+			HashSet<int[]> posses = new HashSet<int[]>();
+			posses.add(pos);
+			attachedBrowserEditor.setHighlightedArea(posses);
+			
+			attachedBrowserEditor.setFocusedWordID(focusid);
+			
+			// reload the page and styles
+			attachedBrowserEditor.backToText(text, line_wordid);// open the page(S) containing the word with id=line_wordid
+			
+			IWorkbenchPage attachedPage = attachedBrowserEditor.getEditorSite().getPage();
+			attachedPage.activate(attachedBrowserEditor);
+
+			return true;
+
+		} catch (Exception err) {
+			Log.severe(NLS.bind("Full text display failed: {0}", err)); //$NON-NLS-1$
+			Log.printStackTrace(err);
+		}
+		return false;
+	}
+}

Index: tmp/org.txm.synopticeditor.rcp/src/org/txm/synopticedition/rcp/handlers/OpenEdition.java
===================================================================
--- tmp/org.txm.synopticeditor.rcp/src/org/txm/synopticedition/rcp/handlers/OpenEdition.java	(revision 0)
+++ tmp/org.txm.synopticeditor.rcp/src/org/txm/synopticedition/rcp/handlers/OpenEdition.java	(revision 653)
@@ -0,0 +1,191 @@
+// Copyright © 2010-2013 ENS de Lyon.
+// Copyright © 2007-2010 ENS de Lyon, CNRS, INRP, University of
+// Lyon 2, University of Franche-Comté, University of Nice
+// Sophia Antipolis, University of Paris 3.
+// 
+// The TXM platform is free software: you can redistribute it
+// and/or modify it under the terms of the GNU General Public
+// License as published by the Free Software Foundation,
+// either version 2 of the License, or (at your option) any
+// later version.
+// 
+// The TXM platform is distributed in the hope that it will be
+// useful, but WITHOUT ANY WARRANTY; without even the implied
+// warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
+// PURPOSE. See the GNU General Public License for more
+// details.
+// 
+// You should have received a copy of the GNU General
+// Public License along with the TXM platform. If not, see
+// http://www.gnu.org/licenses.
+// 
+// 
+// 
+// $LastChangedDate:$
+// $LastChangedRevision:$
+// $LastChangedBy:$ 
+//
+package org.txm.synopticedition.rcp.handlers;
+
+import java.util.ArrayList;
+import java.util.List;
+
+import org.eclipse.core.commands.AbstractHandler;
+import org.eclipse.core.commands.ExecutionEvent;
+import org.eclipse.core.commands.ExecutionException;
+import org.eclipse.jface.viewers.IStructuredSelection;
+import org.eclipse.jface.window.Window;
+import org.eclipse.swt.widgets.Shell;
+import org.eclipse.ui.IWorkbenchPage;
+import org.eclipse.ui.IWorkbenchWindow;
+import org.eclipse.ui.PlatformUI;
+import org.eclipse.ui.handlers.HandlerUtil;
+import org.txm.objects.BaseParameters;
+import org.txm.objects.Text;
+import org.txm.rcp.RCPMessages;
+import org.txm.searchengine.cqp.corpus.Corpus;
+import org.txm.searchengine.cqp.corpus.MainCorpus;
+import org.txm.searchengine.cqp.corpus.Property;
+import org.txm.searchengine.cqp.corpus.StructuralUnit;
+import org.txm.searchengine.cqp.corpus.Subcorpus;
+import org.txm.searchengine.cqp.corpus.query.Match;
+import org.txm.synopticedition.rcp.editors.EditionSelectorDialog;
+import org.txm.synopticedition.rcp.editors.SynopticEditionEditor;
+import org.txm.synopticedition.rcp.editors.SynopticEditorInput;
+import org.txm.synopticedition.rcp.messages.SynopticEditionUIMessages;
+import org.txm.utils.logger.Log;
+import org.w3c.dom.Element;
+import org.w3c.dom.NodeList;
+
+import cern.colt.Arrays;
+// TODO: Auto-generated Javadoc
+/**
+ * Open a text edition from: a main corpus : the first text of the maincorpus a
+ * sub-corpus : the first text of the subcorpus a partition : the user must
+ * choose one of the text used in the partition @ author mdecorde.
+ */
+public class OpenEdition extends AbstractHandler {
+
+	/** The Constant ID. */
+	public final static String ID = "org.txm.synopticedition.rcp.handlers.OpenEdition"; //$NON-NLS-1$
+
+	/** The lastopenedfile. */
+	public static String lastopenedfile;
+
+	/* (non-Javadoc)
+	 * @see org.eclipse.core.commands.AbstractHandler#execute(org.eclipse.core.commands.ExecutionEvent)
+	 */
+	@Override
+	public Object execute(ExecutionEvent event) throws ExecutionException {
+
+		IStructuredSelection selection = (IStructuredSelection) HandlerUtil.getCurrentSelection(event);
+		if (selection.getFirstElement() instanceof Corpus) {
+			try {
+				Corpus c = (Corpus) selection.getFirstElement();
+				Shell shell = HandlerUtil.getActiveWorkbenchWindowChecked(event).getShell();
+
+				EditionSelectorDialog d = new EditionSelectorDialog(shell, c, null);
+				SynopticEditionEditor editor = null;
+				//				if (c.getEditionNames().size() > 1 && d.open() == Window.OK) {
+				//					Object[] rez = d.getResult();
+				//					String[] rezS = new String[rez.length];
+				//					for (int i =0 ; i < rez.length ; i++) rezS[i] = rez[i].toString();
+				//					editor = openEdition(c, rezS);
+				//				} else 
+				String[] editionsToOpen = getDefaultEditions(c);
+
+				if (editionsToOpen.length == 0) { // the defaultEdition parameter is not set
+					ArrayList<String> editionNames = c.getEditionNames();
+					if (editionNames.size() > 0) { // use the first edition declared
+						editionsToOpen = new String[1];
+						editionsToOpen[0] = editionNames.get(0);
+						Log.info(SynopticEditionUIMessages.OpenEdition_0+editionNames.get(0));
+					} else { // no edition in the corpus
+						Log.info(SynopticEditionUIMessages.OpenEdition_1);
+						editionsToOpen = new String[0];
+						return false;
+					}
+				} else {
+					Log.info(SynopticEditionUIMessages.OpenEdition_3+Arrays.toString(editionsToOpen));
+				}
+
+				editor = openEdition(c, editionsToOpen);
+
+				if (editor != null)
+					editor.firstPage();
+
+			} catch (Exception e) {
+				System.out.println(SynopticEditionUIMessages.OpenEdition_4+e);
+				org.txm.rcp.utils.Logger.printStackTrace(e);
+			}
+		} else {
+			System.out.println(SynopticEditionUIMessages.OpenEdition_9);
+		}
+		return null;
+	}
+	public static String[] getDefaultEditions(Corpus c) {
+		BaseParameters params = c.getBase().getBaseParameters();
+		Element editionsElement = params.getEditionsElement(params.getCorpusElement());
+		return editionsElement.getAttribute("default").split(","); //$NON-NLS-1$ //$NON-NLS-2$
+	}
+
+	/**
+	 * Open edition, but don't show a page 
+	 *
+	 * @param corpus the corpus
+	 * @return the object
+	 */
+	public static SynopticEditionEditor openEdition(Corpus corpus, String[] editions) {
+		String textid = null;
+
+		System.out.println("Opening edition of "+corpus); //$NON-NLS-1$
+		try {
+			Text text = null;
+			if (corpus instanceof Subcorpus) {
+				Subcorpus sub = (Subcorpus)corpus;
+				List<Match> matches = sub.getMatches();
+				if (matches.size() > 0) {
+					StructuralUnit text_su = corpus.getStructuralUnit("text"); //$NON-NLS-1$
+					Property text_id = text_su.getProperty("id"); //$NON-NLS-1$
+
+					textid = matches.get(0).getValueForProperty(text_id);
+					if (textid != null) text = corpus.getMainCorpus().getText(textid);
+				}
+			}
+			//			QueryResult result = corpus.query(new Query("<text> []"), "get_edition", false); //$NON-NLS-1$ //$NON-NLS-2$ 
+			//			StructuralUnit text_su = corpus.getStructuralUnit("text"); //$NON-NLS-1$
+			//			Property text_id = text_su.getProperty("id"); //$NON-NLS-1$
+
+			// 			if (result.getNMatch() > 0) textid = result.getMatches(0, 1).get(0).getValueForProperty(text_id);
+			MainCorpus maincorpus = corpus.getMainCorpus();
+
+			//			if (textid != null) text = maincorpus.getText(textid);
+
+			if (text == null) {
+				text = maincorpus.getFirstText();
+
+				if (text == null) {
+					System.out.println("** Could not find first text of ID "+textid+SynopticEditionUIMessages.OpenEdition_7); //$NON-NLS-1$ //$NON-NLS-1$
+					return null;
+				}
+
+				textid = text.getName();
+			}
+
+			//String[] editions = {maincorpus.getDefaultEdition()};
+			IWorkbenchWindow window = PlatformUI.getWorkbench().getActiveWorkbenchWindow();
+			IWorkbenchPage page = window.getActivePage();
+
+			SynopticEditorInput editorInput = new SynopticEditorInput(corpus, text.getName(), editions);
+			SynopticEditionEditor editor = (SynopticEditionEditor) page.openEditor(editorInput,
+					SynopticEditionEditor.ID, true);
+
+			return editor;
+
+		} catch (Exception e) {
+			Log.printStackTrace(e);
+			System.out.println(SynopticEditionUIMessages.OpenEdition_10+e);
+			return null;
+		}
+	}
+}

Index: tmp/org.txm.synopticeditor.rcp/src/org/txm/synopticedition/rcp/preferences/SynopticEditionPreferencePage.java
===================================================================
--- tmp/org.txm.synopticeditor.rcp/src/org/txm/synopticedition/rcp/preferences/SynopticEditionPreferencePage.java	(revision 0)
+++ tmp/org.txm.synopticeditor.rcp/src/org/txm/synopticedition/rcp/preferences/SynopticEditionPreferencePage.java	(revision 653)
@@ -0,0 +1,34 @@
+package org.txm.synopticedition.rcp.preferences;
+
+import org.eclipse.jface.preference.BooleanFieldEditor;
+import org.eclipse.jface.preference.FieldEditorPreferencePage;
+import org.eclipse.ui.IWorkbench;
+import org.eclipse.ui.IWorkbenchPreferencePage;
+import org.eclipse.ui.preferences.ScopedPreferenceStore;
+import org.txm.rcp.Application;
+
+public class SynopticEditionPreferencePage  extends FieldEditorPreferencePage
+implements IWorkbenchPreferencePage {
+	ScopedPreferenceStore preferences;
+
+	private BooleanFieldEditor slow_highlight;
+	
+	
+	public SynopticEditionPreferencePage() {
+		super();
+		preferences = new ScopedPreferenceStore(org.eclipse.core.runtime.preferences.InstanceScope.INSTANCE,
+				Application.PLUGIN_ID);
+		setPreferenceStore(preferences);
+		setTitle("Analec");
+	}
+	
+	@Override
+	public void init(IWorkbench workbench) { }
+
+	@Override
+	protected void createFieldEditors() {
+		slow_highlight = new BooleanFieldEditor(SynopticEditionPreferences.FAST_HIGHLIGHT,
+				"Enable fast word highlight", getFieldEditorParent());
+		addField(slow_highlight);
+	}
+}

Index: tmp/org.txm.synopticeditor.rcp/src/org/txm/synopticedition/rcp/preferences/SynopticEditionPreferences.java
===================================================================
--- tmp/org.txm.synopticeditor.rcp/src/org/txm/synopticedition/rcp/preferences/SynopticEditionPreferences.java	(revision 0)
+++ tmp/org.txm.synopticeditor.rcp/src/org/txm/synopticedition/rcp/preferences/SynopticEditionPreferences.java	(revision 653)
@@ -0,0 +1,18 @@
+package org.txm.synopticedition.rcp.preferences;
+
+import org.eclipse.core.runtime.preferences.DefaultScope;
+import org.osgi.service.prefs.Preferences;
+import org.txm.core.preferences.TXMPreferences;
+
+public class SynopticEditionPreferences extends TXMPreferences {
+
+	public static String PREFERENCES_NODE = "org.txm.synopticedition.rcp.synoptic";
+	
+	public static String FAST_HIGHLIGHT = "org.txm.synopticedition.rcp.synoptic.slow_highlight";
+
+	@Override
+	public void initializeDefaultPreferences() {
+		Preferences preferences = DefaultScope.INSTANCE.getNode(PREFERENCES_NODE);
+		preferences.putBoolean(FAST_HIGHLIGHT, false);
+	}
+}

Index: tmp/org.txm.synopticeditor.rcp/src/org/txm/synopticedition/rcp/messages/SynopticEditionUIMessages.java
===================================================================
--- tmp/org.txm.synopticeditor.rcp/src/org/txm/synopticedition/rcp/messages/SynopticEditionUIMessages.java	(revision 0)
+++ tmp/org.txm.synopticeditor.rcp/src/org/txm/synopticedition/rcp/messages/SynopticEditionUIMessages.java	(revision 653)
@@ -0,0 +1,53 @@
+package org.txm.synopticedition.rcp.messages;
+
+import org.eclipse.osgi.util.NLS;
+import org.txm.utils.messages.Utf8NLS;
+
+public class SynopticEditionUIMessages extends NLS {
+	
+	private static final String BUNDLE_NAME = "org.txm.synopticedition.rcp.messages.messages"; //$NON-NLS-1$
+	
+	public static String BackToText_0;
+	public static String BackToText_1;
+	public static String BackToText_2;
+	public static String BackToText_3;
+	public static String BackToText_4;
+	public static String BackToText_5;
+	public static String EditionPanel_0;
+	public static String EditionPanel_1;
+	public static String EditionPanel_2;
+	public static String EditionPanel_5;
+	public static String EditionPanel_6;
+	public static String EditionPanel_7;
+	public static String EditionSelectorDialog_0;
+	public static String EditionSelectorDialog_1;
+	public static String OpenEdition_0;
+	public static String OpenEdition_1;
+	public static String OpenEdition_10;
+	public static String OpenEdition_2;
+	public static String OpenEdition_3;
+	public static String OpenEdition_4;
+	public static String OpenEdition_7;
+	public static String OpenEdition_9;
+	public static String SynopticEditionEditor_0;
+	public static String SynopticEditionEditor_1;
+	public static String SynopticEditionEditor_10;
+	public static String SynopticEditionEditor_11;
+	public static String SynopticEditionEditor_2;
+	public static String SynopticEditionEditor_3;
+	public static String SynopticEditionEditor_4;
+	public static String SynopticEditionEditor_5;
+	public static String SynopticEditionEditor_6;
+	public static String SynopticEditionEditor_7;
+	public static String SynopticEditionEditor_8;
+	public static String SynopticEditionEditor_9;
+	
+	
+	static {
+		// initialize resource bundle
+		Utf8NLS.initializeMessages(BUNDLE_NAME, SynopticEditionUIMessages.class);
+	}
+
+	private SynopticEditionUIMessages() {
+	}
+}

